#include<bits/stdc++.h>
using namespace std;
int main()
{
    long long n;
    cin>>n;
    bool left[n];
    bool right[n];
    long long previndex=0;
    for(long long i=0; i<n; i++)
    {
        left[i]=false;
        right[i]=false;
    }
    long long ans=n;
    long long prevchislo,chislo;
    cin>>prevchislo;
    for(long long i=1; i<n; i++)
    {
        cin>>chislo;
        if(prevchislo<chislo)
        {
            right[i-1]=false;
            left[i]=true;
        }
        else if(prevchislo>chislo)
        {
            right[i-1]=true;
            left[i]=false;
        }
        else if(prevchislo==chislo)
        {
            right[i-1]=false;
            left[i]=false;
        }
        if(right[i-1] && left[i-1])
        {
            if(previndex!=0)
            {
                ans=min(ans,i-(1+previndex));
            }
            previndex=i;
        }
        prevchislo=chislo;
    }
    cout<<ans;

    return 0;
}
